Stable
------
Version 0.6.23				2025/4
 * 高DPI環境に対応するための関数をいくつか追加（Windowsのみで有効）
 * Windowsの高DPI環境において、ツールバーが小さくなりすぎないようにした
 * Windowsのダークモードに部分的に対応した（メニューバー・メニューのみ）
 * Mac版でヘルプファイルが存在していても見つからないことがあるバグを修正
 
Version 0.6.22-2			2024/5
 * Cocoa版でウィンドウやキャンバスを破棄した際に落ちることがあるバグを修正
 
Version 0.6.22				2023/3
 * gtk3版で文字列を回転させて描画する際に位置がずれるバグを修正
 
Version 0.6.21-9			2020/11
 * gtk3版でWaylandバックエンドを使用している際にアプリケーションが起動しない
   バグを修正
 
Version 0.6.21-8			2020/9
 * gtk版でのコールバックの挙動が他の環境と異なることがあるバグを修正
 * Mac版のトラックバーでSppShowValueが正しく機能しないことがあるバグを
   修正

Version 0.6.21-7			2019/9
 * iOSでフォントダイアログが落ちることがあるバグを修正
 * iOSで端末が回転した場合にファイルダイアログが正しく機能しないことが
   あるバグを修正

Version 0.6.21-6			2019/6
 * SppPercentageWidth, SppPercentageHeightが正しく機能しないことがあるバグを
   修正
 * Windows版のトラックバーでSppShowValueが正しく機能しないことがあるバグを
   修正
 
Version 0.6.21-5			2019/3
 * Windows版でトラックバーの初期値がおかしいことがあるバグを修正
 
Version 0.6.21-4			2019/2
 * DIBitmapPluginを使用したBMPファイルへの出力において、出力されるファイルが
   壊れていることがあるバグを修正
 
Version 0.6.21-3			2019/1
 * Cocoa版のMojaveへの対応
 * Cocoa版でスクロールキャンバスのズーム後、スクロールができなくなることが
   あるバグを修正
 * Android版、iOS版、Cocoa版でスクロールキャンバスのスクロールバーの長さが
   更新されないことがあるバグを修正
 * Cocoa環境で最新のxcodeで動作するようexampleのプロジェクトを更新
 
Version 0.6.21-2			2017/11
 * iOS版でキーボード表示時に端末を回転した際にGUIパーツが正しく
   表示されなくなることがあるバグを修正
 
Version 0.6.21				2017/4
 * 関数の引数や戻り値の必要な箇所に const 修飾子を追加
 * C++から使用した場合に問題が発生することがあるバグを修正

Version 0.6.20-4			2016/11
 * iOS版でキャンバス選択時に常にキーボードが出現するバグを修正
 * Android環境で最新のAndroid Studioで動作するようexampleのプロジェクトを更新
 * iOS環境で最新のxcodeで動作するようexampleのプロジェクトを更新

Version 0.6.20				2016/5
 * spDIBitmapの仕様変更
 * spDIBitmapを使うとMacやiOSでクラッシュすることがあるバグを修正
 * Cocoa版でドラッグ時にマウスムーブコールバックが呼ばれていなかったバグを修正
 * いくつかの環境で起動時にダイアログだけを表示した場合にアプリケーションが
   終了してしまうバグを修正
 * gtk3版でSppTrackCallbackOnがSP_FALSEの際、SpSliderのコールバックが動作
   しないバグを修正
 * iOS版でフォントダイアログが起動しないことがあるバグ（おそらくiOS 9以降の
   環境のみ）を修正
 * Android版でファイルダイアログのファイルフィルターが正しく動作していなかったバグを修正
 * Windows版でポップアップメニューが動作しないことがあるバグを修正
 * gtk3版のspDIBitmapを画像ファイルとして保存する際のバグを修正
 * PSファイルへの印刷時に描画領域が正しく設定されていなかったバグを修正

Version 0.6.19（非公開）		2014/10
 * iOS 8 暫定対応
 * iOS版のピンチ動作時の挙動を改善
 * Android版がTegra2プロセッサなどを用いた端末で動作しないことがあるバグを修正
 * Android版のポップアップメニュー表示の際に落ちることがあるバグを修正
 * Android版でホイール動作が正しく動作しなくなっていたバグ
   （おそらく0.6.17でエンバグ）を修正
 * Android版のツールバーを実装
 * spDialogBoxのフォントダイアログが正しく機能しないことがあるバグを修正

Version 0.6.18（非公開）		2014/8
 * iOS対応（非オープンソース）
 * 画像ファイルをspDIBitmapとして読み込む機能・spDIBitmapを画像ファイルとして
   保存する機能を追加
 * Windows版でspWaitThreadLoopが待ち続けることがあるバグを修正
 * Windows 8で高解像度PCを用いた場合に初期状態のウィンドウの大きさが
   おかしいことがあるバグを修正
 * 複数ページの印刷への対応
 * Cocoa版の印刷機能を正式実装
 * Cocoa版で終了時にたまに落ちるバグを修正
 * Cocoa版でウィンドウを最初に表示させた際にキャンバスの描画がされないことが
   あるバグを修正
 * gtk版でドラッグ＆ドロップでファイルが読めないことがあるバグを修正
 * gtk-1.2でコンパイルできないバグを修正
 * spDIBitmapでメモリーリークしていたバグを修正
 * Android版でキャンバスのポップアップメニューが動作しないバグを修正
 * Android版で終了時に落ちることがあるバグを修正
 * 印刷プラグインのページ設定ダイアログが機能していないバグを修正
 * Cygwin上のmingwでコンパイルできるようにした

Version 0.6.17（非公開）		2014/1
 * spComponent.cに関数をいくつか追加
 * Cocoa版でフォントダイアログが落ちるバグを修正
 * spParseFontNameで正しくフォント名が取得できないことがあるバグを修正
 * Android版をAndroid 3以降の環境で使うとspTabBoxが動作しないバグを修正
 * Android版をAndroid 3以降の環境で使うとダイアログが動作しないバグを修正

Version 0.6.16				2013/8
 * gtk2版のspGetNumListItemで落ちるバグを修正

Version 0.6.15				2013/4
 * spParamFieldで初期状態においてsensitiveが有効でないことがあるバグを修正
 * spTextの文字列のメモリーリークのバグを修正
 * spDialogBoxに関数をいくつか追加
 * Cocoa版で特殊キーによるショートカットのいくつかが機能しないバグを修正
 * Windows版で終了できなくなることがあるバグを修正

Version 0.6.14				2012/9/3
 * マルチスレッドアプリケーションのスレッドが異常終了するバグ（spThreadのバグ）を修正
 * MotifでspStretchImageが異常に遅いバグを修正
 * MotifのUTF8の環境で文字化けすることがあるバグを修正
 * gtk3正式対応
 * gtk3で印刷に対応
 * gtk2以降で文字の回転に対応
 * 印刷プラグインの仕様を若干変更
 * spDrawArc, spFillArcの描画角度が負の場合のバグを修正
 * gtkでテキストエリアの文字列が正しく更新できないバグを修正
 * Windowsでショートカットに＋や−などの記号を使えなかったバグを修正
 * Motifでコールバック関数の削除ができていなかったバグを修正
 * Windows XP以降でspTabBoxの表示が、テーマ使用の場合におかしいバグを修正
 * Windows でメニューバーの描画が時々おかしくなるバグを修正
 * spTabBoxの挙動を改善
 * spTabBox関連の関数を追加
 * MacでのspComboBoxの挙動を改善

Version 0.6.13（非公開）
 * 64bit OS正式対応
 * フォント名にマイナス文字が入っていた場合に正しく動作しないバグを修正
 * spGetArgsのバグ修正
 * Cocoa対応（非オープンソース）
 * Android対応（非オープンソース）
 * Motifで編集不可のコンボボックスを選択すると固まるバグを修正

Version 0.6.12（非公開）
 * モーダルウィンドウが開いている場合、他のウィンドウのショートカットが
   有効になっていたバグを修正

Version 0.6.11				2009/8/23
 * TrackBarのSppDecimalPoints（小数点以下の桁数）の設定を機能するようにした
 * spParamFieldにTrack Bar with TextとTrack Bar with Combo Boxを追加
 * Windowsで、spListのspSelectListItemが機能しなかったバグを修正
 * Macで、SppShowValueがオンのときのトラックバーの値が正しく表示されないバグ
   を修正
 * spPrimitiveにイベントコールバックを複数指定できるようにした

Version 0.6.10				2009/2/4
 * プログレスバーの実装
 * ウィンドウのフルスクリーン表示の実装

Version 0.6.9				2007/10/2	banno
 * プラグインによる印刷機能の実装
 * ポリゴンの描画の実装
 * スレッドからユーザーイベントを発行する関数の実装
 * spObjectの関数仕様変更
 * Macでメニューの選択ができないことがあったバグを修正

Version 0.6.8（非公開）			2007/8		banno
 * タイマーコールバックの実装
 * WindowsでWM_PAINTメッセージがうまく扱えず、無限ループに陥る
   可能性があったバグを修正
 * 編集可能なコンボボックスでツールチップが出なかったバグを修正
 * コンテナの初期サイズが無効になっていたバグを修正
 * spDialogBox でクローズコールバックが発生していなかったバグを修正
 * spList関連関数を追加

Version 0.6.7				2006/8/21	banno
 * spGetString の仕様を変更
 * WindowsでHTMLHelpを使用するようにした
 * Cygwin + X11 + gtk2 でgtkバージョンをコンパイルできるようにした
 * マルチスレッド用の関数をいくつか追加

Version 0.6.6				2004/4/26	banno
 * gtk2 暫定対応
 * spParamFieldにTrack Barを追加
 * Windowsで縦方向のスクロールバーの動きが逆になることがあるバグを修正
 * Motifでカラー選択ダイアログの動作がおかしいバグを修正
 * Cygwin + X11 + Lesstif でMotifバージョンをコンパイルできるようにした

Version 0.6.5-3				2002/4/29	banno
 * gccのいくつかのバージョンでSJISの文字が原因でコンパイルできなくなる
   バグを修正

Version 0.6.5-2				2002/4/7	banno
 * Mac OS 8で、spSliderのデバッグメッセージが原因で落ちるバグを修正
 * Mac OS 8で、タブのタイトルが表示されないことがあるバグを修正

Version 0.6.5				2002/2/17	banno
 * Mac OS Xのサポート
 * フォント設定ダイアログの実装
 * カラー設定ダイアログの実装
 * テキストの範囲選択やカーソルの位置を制御する関数を実装
 * spTextのフォント設定を可能にした
 * モディファイアキーを得る関数を実装
 * リストのコールバックを実装
 * メッセージダイアログを親なしでも動作するように仕様変更
 * MacでSppCloseStyleがSP_NO_CLOSEのウィンドウでも閉じたときに
   コールバックが発生していたバグを修正
 * Macでメモリ解放したカーソルを使用していたバグを修正
 * ウィンドウのSppOrientation がSP_HORIZONTALのときに
   ツールバーがあると挙動がおかしくなるバグを修正
 * Motif バージョンで、ダイアログのキャプチャーがおかしいバグを修正
 * Motif バージョンで、リストにアイテムを追加すると現在選択されているアイテムを
   うまく取得できないバグを修正
 * Windowsでリストのアイテムを削除したときのエラー値がおかしいバグを修正
 * ライブラリ内などへの使用のため、spStringTableを起動後にも追加できるようにした
 * spComponentのDestroy後のメモリーリークを減らした
 * WindowsでDestroy後にもコールバックが有効になっていてSeg. Faultを
   引き起こすことがあるバグを修正
 * Windowsでマウスカーソルがうまく変わらないことがあるバグを修正
 * WindowsでspGraphicsの色を変えても変わらないバグを修正
 * Windowsでテキストのコールバックが複数回呼ばれることがあるバグを修正
 * WindowsでspGetCallbackKeySymがうまく機能しないことがあるバグを修正
 * gtkでPOINTER_MOTIONでもBUTTON_MOTIONのコールバックが呼ばれていたバグを修正
 * チェックツールアイテムが起動時にチェックにならないバグを修正

Version 0.6.4				2001/3/12	banno
 * Windowsでキャンバスのビットマップリソースを解放しないバグを修正
 * gtkバージョンで、スレッドを使うとおかしくなるバグを修正
  （0.6.3からのバグです）
 * クローズボタンでウィンドウを閉じたときに
   常にSP_CLOSE_CALLBACKが発生するように仕様変更
 * SppCloseStyleにSP_CALLBACK_CLOSEを実装
 * コールバックのメモリー関係のバグを修正
  （このバグのためWindows 2000で起動しないことがあった）
 * オプションダイアログにツールチップを表示するようにした
 * Mac OSでテキストフィールドに値をセットすると他の部分が描画されることがあるバグを修正

Version 0.6.3				2001/1/4	banno
 * 一部の環境でダイアログのデフォルトボタンやエスケープキーによるクローズを有効にした
 * Windowsでタブキーによるフォーカスの変更を可能にした
 * Windowsでデザインを変更しているときにダイアログの描画がおかしいバグを修正
 * Mac OSでツールバー、ツールチップを実装
 * Mac OS 7.5.3で動作するようになった
 * Mac OS 8.1以降でのアピアランスのサポート
 * Mac OS 8.1以降でのシフトキーとコントロールキーを用いたショートカットのサポート
 * gtkバージョンでテーマを変更しているときにダイアログの描画がおかしいバグを修正
 * Mac OSでダイアログをメニューから閉じたときにクラッシュするバグを修正
 * Mac OS 9でタブをクリックしたときに激しく点滅するバグを修正
 * Mac OS 9でスマートスクロールに対応
 * Windowsでテキストフィールドのアクティベートが働かないバグを修正
 * Windowsで画面のデザインを変更しているときにspGetSystemGraphicsの戻り値を変更
 * Windowsでダイアルが2つあるときにうまく動作しないバグを修正
 * ダイアルをキーでも操作できるようにした

Version 0.6.2				2000/10/21	banno
 * Windows、gtk、Mac OSバージョンでスレッドに対応
 * Windows、gtk、Mac OSバージョンでdrag & dropに対応
 * Windows のspTextのコールバックが動作しないバグを修正
 * Windows のspTextFieldを自動スクロールするようにした
 * Windows のラジオメニューアイテムのチェックマークを変更した
 * Windows のxspGetOpenFileNameとxspGetSaveFileNameが親なしの場合に動作しないバグを修正
 * Mac OSでコンボボックスのリストを選択してもコールバックが呼ばれないバグを修正

Version 0.6.1				2000/8/16	banno
 * Macintosh バージョンの実装
 * 関数の可変引数の実装を変更
 * 入れ子の modal window の作成が可能になった
 * Windows バージョンで、 spContainer の sensitive を設定したときに、
   その子供の sensitive も変わるようにした
 * gtk バージョンのファイルダイアログが、親ウィンドウを閉じた後に
   クラッシュするバグを修正
 * gtk バージョンの spToolItem の描画のバグを修正
 * SP_DESTROY_CALLBACK の実装を変更
 * 元々のSP_DESTROY_CALLBACKはSP_CLOSE_CALLBACKに変更
 * Windows バージョンのspTextで、ヌル文字列が獲得できないバグを修正
 * ニーモニックを扱う関数で、`&&'により`&'が画面に表示されるようにした
 * マウスカーソルを変更する関数の作成
 * Windowsでのウィンドウの初期位置を決める方法を変更

Version 0.6.0 （非公開）		2000/2/10	banno
 * オプションダイアログの作成
 * チェックツールアイテムの実装
 * gtk バージョンのファイルダイアログで、ファイルの種類を選択できるようにした
 * gtk バージョンのキーボードコールバックが動作しないバグを修正
 * gtk バージョンで、spCanvasのフォーカスする際のバグを修正
 * Motif バージョンのマウスのキャプチャーがいくつかの環境でうまくいかないバグを修正
 * Motif バージョンでフォントが見つからなかったときにクラッシュするバグを修正
 * Windows バージョンで、タスクトレイへのアイコンの表示をサポート


Developmental
-------------
Version 0.5.5				1999/9/13	banno
 * 最初のオフィシャルリリース

Version 0.4.1 （非公開）		1999/5/9	banno
 * spTabBox、spStatusBarの追加
 * いくつかのバグフィックス

Version 0.4.0 （非公開）		1999/4/15	banno
 * 多くの関数、コンポーネントの追加
 * いくつかのバグフィックス

Version 0.1.0 （非公開）		1998/9		banno
 * 最初のバージョン
